/*******************************************************************
*******  Copyright (c)            Alexandros V. Gerbessiotis       *
******* All rights reserved; read copyag.txt file                  *
*******************************************************************/
#include "ssrt.h"
/* Standard quicksort */
void ag51qdro (void *akeys, int n, int size, int (*compare) (const void*,const void*),int l,int r)
{
 register int M,c,i,j;
 register char *pi,*pj,*pp,*SRC,*DES;
 register char *keys=(char*) akeys, *split;
 static char X[64];

 if (n <=1) return;
 split=X;



 i=l;j=r;
 pi= keys+l*size;
 pj= keys+r*size;

 MEMCPY(split,keys+((l+r)>>1)*size,size);

do
{
   while (compare(pi,split) < 0)  {i++; pi += size;}
   while (compare(split,pj) < 0)  {j--; pj -= size;}
   if (i <= j ) {
      M=size;
      do  { c=*pi; *pi++=*pj;*pj++=c;} while (--M);
      i++;j--;pj-=size;pj-=size;
    }
}   while (i <= j);
	
	if (l < j) {
		if ((j-l) < THRES16) {
                   pi=keys+l*size;
                   for(pj=pi+size;pj< pi+(j-l+1)*size;pj+=size){
                     MEMCPY(split,pj,size);
                     for(pp=pj;pp > pi &&(compare(pp-size,split)>0); pp-=size){
                       MEMCPY((pp),(pp-size),size);
                     }
                     MEMCPY((pp),split,size);
                   }
                }
		else
			ag51qdro (keys,n,size,compare,l,j);
        }
	if (i < r) {
		if ((r-i) < THRES16) {
                   pi=keys+i*size;
                   for(pj=pi+size;pj< pi+(r-i+1)*size;pj+=size){
                     MEMCPY(split,pj,size);
                     for(pp=pj;pp > pi &&(compare(pp-size,split)>0); pp-=size){
                       MEMCPY((pp),(pp-size),size);
                     }
                     MEMCPY((pp),split,size);
                   }
                }
		else
			ag51qdro (keys,n,size,compare,i,r);
        }
	
}

void ag51qdo (void *keys, int n, int size, int (*compare) (const void*,const void *))
{
  ag51qdro (keys,n,size,compare,0,n-1);
}
