/**** 2019 (c)  All rights reserved: see agcopy19.txt ****/
#include "agssrti.h"
#ifndef MEMCPY
#define MEMCPY(X,Y,SIZE)  memcpy((X),(Y),(SIZE))
#endif
 /* (Straight) Insertion Sort */

void f1ins1(double *src,int n)
{   /* j=i-1 */
  register int i,j;
  register double k;

  if (n <= 1) return;
  for (i=1;i<n;++i){
     k=src[i];
     j=i-1;
     while ((j >= 0) && (src[j] > k)) {
        src[j+1] = src[j];
        --j;
     }
     src[j+1]=k;
  }
}

void f1ins2(double *src,int n)
{   /* j=i */
   register int i,j;
   register double k;

 if (n <= 1) return;
 for (i=1;i<n;++i) {
    k= src[i];
    j=i;
    while (( j > 0) && (src[j-1] > k)) {
      src[j]=src[j-1];
      --j;
    }
    src[j]=k;
 }
}

void f1ins7(double *src,int n)
{   /* j=i-1 , p, ip, for */
  register double  k;
  register double *p,*ip;

  if (n <= 1) return;
  for(ip=src+1;ip<(src+n);++ip) {
     k=*ip;
     for( p = ip ; (ip > src) && (*(p-1) > k) ; --p){
        *p= *(p-1);
     }
     *p=k;
  }
}

void f1ins8(double *src,int n)
{   /* j=i-1 , p, ip, for */
  register double *p,*ip;

  if (n <= 1) return;
  for(ip=src+1;ip<(src+n);++ip) {
     for( p = ip ; (ip > src) && (*(p-1) > *ip) ; --p){
        *(p)= *(p-1);
     }
     *(p+1)= *ip;
  }
}


