/**** 2019 (c)  All rights reserved: see agcopy19.txt ****/

#include "agssrt.h"
#ifndef MEMCPY
#define MEMCPY(X,Y,SIZE)  memcpy((X),(Y),(SIZE))
#endif

/* BinarySearch Insertion Sort */

void q1inb1(void *akeys, int n, int size, int (*compare) (const void*,const void*))
{
 register int M;
 register char *SRC, *DES;
 register int i,j,l,r,m;
 register char  *x,*keys;

 if (n<=1) return;
 keys = (char *) akeys;
 x    = (char *) malloc(size*sizeof(char));

 for(i=1;i<n;++i) {
    MEMCPY(x,keys+i*size,size); /* &keys[i*size] */
    l=0;r=i-1;
    while (l <= r) {
       m = (l+r)/2;
       if (compare(x,keys+m*size) < 0) /* &keys[m*size] */
          r=m-1;
       else
          l=m+1;
    }

    for(j=i-1;j>=l;j--)
        MEMCPY(keys+(j+1)*size,keys+j*size,size);
        MEMCPY(keys+l*size,x,size);
 }
 free((void*)x);
}
