/**** 2019 (c)  All rights reserved: see agcopy19.txt ****/
#include "agssrt.h"
#ifndef MEMCPY
#define MEMCPY(X,Y,SIZE)  memcpy((X),(Y),(SIZE))
#endif

 /* QuickSort Recursive using while ; no   optimizations  */

void q6qkry1a(void *akeys, int n, int size, int (*compare) (const void*,const void*))
{
  register int M;
  register char *SRC, *DES;
  register char *tmp, *split,*keys = (char*) akeys;
  register int l,r;

if (n <= 1) return;
 keys= (char *) akeys;
 tmp = (char *) malloc(size*sizeof(char));
 split=(char *) malloc(size*sizeof(char));
 l=0;r=n-1;
#if SPLITTER == MIDDLE_KEY
 memcpy(split,&keys[((l+r)>>1)*size],size);
#elif SPLITTER == FIRST_KEY
 memcpy(split,&keys[l*size],size);
#elif SPLITTER == RANDOM_KEY
 memcpy(split,&keys[(l+GRANDOM((r-l+1)))*size],size);
#endif

 while (l <= r) {
   while (compare(&keys[l*size],split)<0) l++;
   while (compare(split,&keys[r*size])<0) r--;
   if (l <= r) {
     MEMCPY(tmp,&keys[l*size],size);
     MEMCPY(&keys[l*size],&keys[r*size],size);
     MEMCPY(&keys[r*size],tmp,size);
     l++;r--;
   }
 }

 if (r>0) {
      if ((r+1)<THRES16) BASES (keys,r+1,size,compare) ;
      else q6qkry1a(keys,r+1,size,compare) ;
  }
  if (l < n) {
      if ((n-l)<THRES16) BASES (&keys[l*size],n-l,size,compare) ;
      else q6qkry1a(&keys[l*size],n-l,size,compare) ;
  }
 free((void *)split); free((void *)tmp);

}

void q6qkry1  (void *keys, int n, int size, int (*compare) (const void*,const void *))
{
  if (n <= 1) return ;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
  q6qkry1a  (keys,n,size,compare);
}

