/*******************************************************************
*******  Copyright (c)            Alexandros V. Gerbessiotis       *
******* All rights reserved; read ../copyag.txt file               *
*******************************************************************/
#include <memory.h>
#include <limits.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

typedef int    data;

#ifndef MIN
#define	MIN(x,y)	((x)<=(y)?(x):(y)) 
#endif

#define GRANDOM(X)  (int)((random()/((double)2147483647.0))*X)
#define GSRANDOM()   srandom((unsigned int)time(NULL))

        /* THRES16 16 or 24 , TMERGE 8 or 16 */
#define THRES16   24
#define TMERGE    16
#define BASES     ag21ins 

#define FIRST_KEY  0
#define MIDDLE_KEY 1
#define RANDOM_KEY 2
#define SPLITTER  MIDDLE_KEY

#define SWAPP(i1,i2) \
  {ii = size;do {k = *(i1);*(i1)++ = *(i2);*(i2)++ = k;} while(--ii);}
#define SWAPPY(XX,YY,TT,SS) {DES=(XX);SRC=(YY);M=(SS); do {*TT=*DES;*DES++=*SRC;*SRC++=*TT;} while ( --M); }

/*
#undef  MEMCPY
#define MEMCPY(X,Y,SIZE)  memcpy((X),(Y),(SIZE))
#define IMEMCPY(XX,YY,SS) {DES=(XX);SRC=(YY);M=(SS); do {*DES++=*SRC++;} while (--M); }
*/
#define MEMCPY(XX,YY,SS) {DES=(XX);SRC=(YY);M=(SS); do {*DES++=*SRC++;} while (--M); }

void gnu01    (void *,int ,int ,int (*)(const void*,const void*));
void gnu02    (void *,int ,int ,int (*)(const void*,const void*));

void ag21ins  (void *,int ,int ,int (*)(const void*,const void*));
void ag22ins  (void *,int ,int ,int (*)(const void*,const void*));
void ag23ins  (void *,int ,int ,int (*)(const void*,const void*));

void ag30mi   (void *,int ,int ,int (*)(const void*,const void*));
void ag30mii  (void *,int ,int ,int (*)(const void*,const void*));
void ag43hx   (void *,int ,int ,int (*)(const void*,const void*));
void ag45hx   (void *,int ,int ,int (*)(const void*,const void*));

void ag47qw   (void *,int ,int ,int (*)(const void*,const void*));
void ag48qw   (void *,int ,int ,int (*)(const void*,const void*));
void ag48qwo  (void *,int ,int ,int (*)(const void*,const void*));
void ag49qw   (void *,int ,int ,int (*)(const void*,const void*));
void ag49qwo  (void *,int ,int ,int (*)(const void*,const void*));
void ag50qw   (void *,int ,int ,int (*)(const void*,const void*));
void ag50qwo  (void *,int ,int ,int (*)(const void*,const void*));
void ag51qd   (void *,int ,int ,int (*)(const void*,const void*));
void ag51qdo  (void *,int ,int ,int (*)(const void*,const void*));
void ag51qro  (void *,int ,int ,int (*)(const void*,const void*));
