/****(c) 2020. A. Gerbessiotis. See ../KAagcopy.txt ****/
/*******************************************************/
#include "agssrtd.h"

 /* Data QuickSort Recursive using for  CLRS version (used to be d7clrs)  */

void d6qkrf1a (ddata *keys, int n, unsigned int l, unsigned int r) /* i63fbc */
{
  register unsigned int i,j;
  register ddata pr,pm,tmp;

  if (n<=1) return;
  pr=*(keys+r);
#if   SPLITTER == MIDDLE_KEY
 pm   =keys[(l+r)>>1];
#elif SPLITTER == FIRST_KEY
 pm   =keys[l];
#elif SPLITTER == RANDOM_KEY
 pm   =keys[l+GRANDOM((r-l+1))];
#endif
tmp=pm; pm=pr; pr=tmp;
i=l-1; j=l;

  for(j=l;j<r;++j) {
    if (keys[j]<=keys[r]) {
       ++i;
       tmp=*(keys+j);
       *(keys+j)=*(keys+i);
       *(keys+i)=tmp;
    }
  }
  ++i;
  tmp=*(keys+r);
  *(keys+r)=*(keys+i);
  *(keys+i)=tmp;

  if ((i-l) < INQSSZE )
    INQSIS(keys+l,(i-l));
  else
     d6qkrf1a(keys+l,i-l,0,i-l-1);
  if ((r-i) < INQSSZE )
    INQSIS(keys+(i+1),(r-i));
   else
     d6qkrf1a(keys+(i+1),r-i,0,r-i-1);

}

void d6qkrf1(ddata *keys, int n)
{
 if (n<=1) return;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
   d6qkrf1a(keys,n,(unsigned int) 0,(unsigned int) (n-1));
}
