/****(c) 2020. A. Gerbessiotis. See ../KAagcopy.txt ****/
/*******************************************************/
#include "agssrtd.h"
#ifndef MEMCPY
#define MEMCPY(X,Y,SIZE)  memcpy((X),(Y),(SIZE))
#endif

 /* Integer QuickSort Non-Recursive using do  ; very simple version */
void d7qknd1(ddata *keys, int n)
{
  register int i,j,l,r,s;
  register ddata  x,y;
  int   lstack[STSZ];
  int   rstack[STSZ];
 if (n<=1) return;
  s=0;
  lstack[0]=0;rstack[0]=n-1;
  do {
    l=lstack[s]; r=rstack[s]; --s;
    do {
      i=l;
      j=r;
      x=keys[(l+r)/2];
      do {
        while (keys[i] < x) ++i;
        while (x<keys[j] )  --j;
        if (i <= j ) {
          y=keys[i];
          keys[i]=keys[j];
          keys[j]=y;
          ++i; --j;
        }
       } while (i <= j);
       if (i < r) {
         ++s; lstack[s]=i; rstack[s]=r;
       }
       r=j;
    } while ( l < r);
  } while (s>= 0);
}

void d7qknd2 (ddata *keys, int n)
{
 register int  i,j,l,r,s;
 register ddata split,tmp;
 int    lstack[STSZ];
 int    rstack[STSZ];

 if (n<=1) return;
 s=0;
 lstack[0]=0;rstack[0]=n-1;
 do {
   l=lstack[s]; r=rstack[s]; --s;
   do {
     i=l;
     j=r;
     split=keys[(l+r)/2];
     do {
       while (keys[i] < split) ++i;
       while (split<keys[j])   --j;
       if (i <= j ) {
         tmp=keys[i];
         keys[i]=keys[j];
         keys[j]=tmp;
         ++i; --j;
       }
     } while (i <= j);
     if (i < r) {
       if ((r-i)<INQSSZE ) {
        INQSIS(&keys[i],(r-i+1));
       }
       else {
            ++s; lstack[s]=i; rstack[s]=r;
       }
      }
      r=j;
    } while ( l < r);

} while (s>= 0);

}
