/****(c) 2020. A. Gerbessiotis. See ../KAagcopy.txt ****/
/*******************************************************/
#include "agssrt.h"

  /* (Straight) Insertion Sort */
  /* middle one q1ins21 aka q1ins1 (is ins5) :  7 < q1ins21== ins 5 */
  /*            q1ins22 aka q1ins2 */

void SWAP(char *x, char *y, int    size)
{
  while(size-- > 0) {
    char tmp = *x;
    *x++ = *y;
    *y++ = tmp;
  }
}
void q1ins5(void *akeys, int n, int size, int (*compare) (const void*,const void*))
{   /* j=ip , p */
 register int  M;
 register char *SRC, *DES, *k, *p, *ip;
 register char *keys=(char*)akeys;

 if (n <=1) return;
 k    = (char *) malloc(size*sizeof(char));

 for(ip=keys+size; ip< (keys+n*size); ip += size) {
    MEMCPY(k, ip, size);
    p=ip-size;
    while ( (p >= keys ) && (compare(p,k) > 0 )) {
       MEMCPY(p+size, p, size);
       p-=size;
    }
    MEMCPY((p+size), k, size);
 }
 free((void*) k );
}

void q1ins1(void *akeys, int n, int size, int (*compare) (const void*,const void*))
{
 register int  M;
 register char *SRC,*DES, *p, *jp, *k;  
 register char *keys= (char*) akeys ;

 if (n <=1) return;
 k   = (char *) malloc(size*sizeof(char));
 for(jp=keys+size; jp<(keys+n*size); jp+=size) {
   MEMCPY(k,jp,size);
   p=jp-size;
   while ( (p>=keys) && ( compare(p,k)>0) ) {
     MEMCPY((p+size),(p),size);
     p-=size;
   }
   MEMCPY((p+size), k, size);
 }
 free((void *) k );
}

void q1ins7(void *akeys, int n, int size, int (*compare) (const void*,const void*))
{
 register int  M;
 register char *SRC, *DES, *p, *ip, *k;
 register char *keys=(char*)akeys;

 if (n <=1) return;
 k    = (char*) malloc(size*sizeof(char));

 for(ip=keys+size; ip < (keys+n*size) ; ip += size) {
    MEMCPY(k, ip, size);
    for( p = ip ; (p > keys ) && (compare(p-size, k) > 0 ); p-=size){
       MEMCPY(p,p-size,size);
    }
    MEMCPY(p, k, size);
 }
 free((void *) k );
}

void q1ins2(void *akeys, int n, int size, int (*compare) (const void*,const void*))
{
 register int  M;
 register char *SRC,*DES, *p, *jp, *k;
 register char *keys= (char*) akeys;

 if (n <=1) return;
 k   = (char *) malloc(size*sizeof(char));
 for(jp=keys+size; jp<(keys+n*size); jp+=size) {
   MEMCPY(k,jp,size);
   for(p=jp;p > keys &&( compare(p-size,k)>0); p-=size){
     MEMCPY((p),(p-size),size);
   }
   MEMCPY((p),k,size);
 }
 free((void *) k);
}

/* BinarySearch Insertion Sort */

void q1inb1(void *akeys, int n, int size, int (*compare) (const void*,const void*))
{
 register int M;
 register char *SRC, *DES;
 register int i,j,l,r,m;
 register char  *x,*keys;

 if (n<=1) return;
 keys = (char *) akeys;
 x    = (char *) malloc(size*sizeof(char));

 for(i=1;i<n;++i) {
    MEMCPY(x,keys+i*size,size); /* &keys[i*size] */
    l=0;r=i-1;
    while (l <= r) {
       m = (l+r)/2;
       if (compare(x,keys+m*size) < 0) /* &keys[m*size] */
          r=m-1;
       else
          l=m+1;
    }

 for(j=i-1;j>=l;j--)
    MEMCPY(keys+(j+1)*size,keys+j*size,size);
 MEMCPY(keys+l*size,x,size);
 }
 free((void*)x);
}

