/****(c) 2020. A. Gerbessiotis. See ../KAagcopy.txt ****/
/*******************************************************/
#include "agssrt.h"


void q6qkrd1a
(void *akeys, int n, int size, int (*compare) (const void*,const void*),int l,int r)
{
 register int i,j,m,c;
 static char x[64];
 register char *keys=(char*) akeys;
 register char *pi,*pj;

 i=l;j=r;
 pi=  keys+l*size ;
 pj=  keys+r*size ;
/*
 x = (char *) malloc(size*sizeof(char));
 y = (char *) malloc(size*sizeof(char));
*/
 memcpy(x,keys+((l+r)>>1)*size,size);
 do {
        while (compare(pi,x) < 0)  {++i; pi += size;}
        while (compare(x,pj) < 0)  {--j; pj -= size;}
        if (i <= j ) {
        /* memcpy(y,pi,size);
        memcpy(pi,pj,size);
        memcpy(pj,y,size);
        ++i;--j; pi += size;pj -= size; */
        m=size;
        do  {
             c=*pi; *pi++=*pj;*pj++=c;} while (--m);
                ++i;--j;pj-=size;pj-=size;
        }
 } while (i <= j);

        if (l < j) {
                if ((j-l) < NQSSZE )
                        NQSIS(keys+l*size ,(j-l+1),size,compare);
                else
                        q6qkrd1a(keys,n,size,compare,l,j);
        }
        if (i < r) {
                if ((r-i) < NQSSZE )
                        NQSIS(keys+i*size,(r-i+1),size,compare);
                else
                        q6qkrd1a(keys,n,size,compare,i,r);
        }

/*
 free((void *)x); free((void *)y);
*/
}


void q6qkrd1(void *keys, int n, int size, int (*compare) (const void*,const void *))
{
  q6qkrd1a(keys,n,size,compare,0,n-1);
}



 /* QuickSort Recursive using do ; inline memcpy ; inline insertion sort ;  static x  Tail recursion */
void q6qkrd2a (void *akeys, int n, int size, int (*compare) (const void*,const void*),int l,int r)
{
 register int M;
 register char *SRC, *DES;
 register char *keys=(char*) akeys;
 register char *x,*pi,*pj,*pp;
 register int i,j,c;
 static char X[64];

 x=X;
 i=l;j=r;
 pi= keys+l*size;
 pj= keys+r*size;

 MEMCPY(x,&keys[((l+r)>>1)*size],size);

do
{
        while (compare(pi,x) < 0)  {++i; pi += size;}
        while (compare(x,pj) < 0)  {--j; pj -= size;}
        if (i <= j ) {
          M=size;
          do  {
             c=*pi; *pi++=*pj;*pj++=c;} while (--M);
                i++;j--;pj-=size;pj-=size;
        }
} while (i <= j);

        if (l < j) {
                if ((j-l) < NQSSZE ) {
                   pi=keys+l*size;
                   for(pj=pi+size;pj< pi+(j-l+1)*size;pj+=size){
                     MEMCPY(x,pj,size);
                     for(pp=pj;pp > pi &&(compare(pp-size,x)>0); pp-=size){
                       MEMCPY((pp),(pp-size),size);
                     }
                     MEMCPY((pp),x,size);
                   }
                }
                else
                        q6qkrd2a  (keys,n,size,compare,l,j);
        }
        if (i < r) {
                if ((r-i) < NQSSZE ) {
                   pi=keys+i*size;
                   for(pj=pi+size;pj< pi+(r-i+1)*size;pj+=size){
                     MEMCPY(x,pj,size);
                     for(pp=pj;pp > pi &&(compare(pp-size,x)>0); pp-=size){
                       MEMCPY((pp),(pp-size),size);
                     }
                     MEMCPY((pp),x,size);
                   }
                }
                else
                        q6qkrd2a  (keys,n,size,compare,i,r);
        }


}

void q6qkrd2 (void *keys, int n, int size, int (*compare) (const void*,const void *))
{
  if (n<=1) return;
  q6qkrd2a  (keys,n,size,compare,0,n-1);
}


