/****Copyright (c) 1997-2004 All rights reserved
 ****A. V. Gerbessiotis 
 ****Permission to use, copy, modify, and distribute this software,
 ****and to incorporate it, in whole or in part, into 
 ****other software,is hereby granted without fee, provided that
 ****  (1) the above copyright notice and this permission 
 ****      notice appear in all copies of the source code, and 
 ****      the above copyright notice appear in clearly visible 
 ****      form on all supporting documentation and distribution 
 ****      media, and
 ****     (2) any redistribution of the software, in original
 ****         or modified form, be without fee and subject to
 ****         these same conditions.
 ****   No guarantee, whatsoever, is offered that the code works as
 ****   advertised or is absent of any, even damaging,
 ****   side-effects. Use this code at your own personal risk.
 ****/
#include "ssrt.h"
/*Optimized? g41qsnt/g48qsnt */

void ag73qsnt(void *akeys, int n, int size, int (*compare) (const void*,const void*))
{
 register int i,j,l,r,s,m,c;
 char X[64];
 char *keys;
 register char  *x,*pi,*pj,*t,*u;
 static int	lstack[STSZ];
 static int	rstack[STSZ];

  keys = (char *) akeys;
  x=X;
  s=0;
  lstack[0]=0;rstack[0]=n-1;
do {
    l=lstack[s]; r=rstack[s]; s--;
    do {
	i=l; 
	j=r; 
	t=x;u=&keys[((l+r)>>1)*size];
        m=size;
        do { *t++ = *u++; } while (--m);
        
        pi=&keys[i*size];
        pj=&keys[j*size];
	do {
          while (compare(pi,x) < 0) {i++;pi+=size;}
          while (compare(x,pj) < 0) {j--;pj-=size;}

	  if (i <= j ) {
            m=size;
            do {
             c= *pi;
             *pi++ = *pj;
             *pj++ = c;
            } while (--m);
            i++; pj -=size;
            j--; pj -=size;
           }
	} while (i <= j); 
		
	if (i < r) {
          if ((r-i) <THRES16 )
	    BASES (pi,(r-i+1),size,compare);
          else {
	    s++; lstack[s]=i; rstack[s]=r;
          }
        }
	r=j;
      } while ( l < r);

   } while (s>= 0);
}
