/**** 2019 (c)  All rights reserved: see agcopy19.txt ****/


#include <memory.h>
#include <limits.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

typedef int    data;

#ifndef MIN
#define	MIN(x,y)	((x)<=(y)?(x):(y)) 
#endif

#define GRANDOM(X)  (int)((random()/((double)2147483647.0))*X)
#define GSRANDOM()   srandom((unsigned int)time(NULL))

/* 2019 code definitions start here */
/* BSRTSZE is for merge-sort's insertionsort */
/* RSRTSZE is for quicksort's recursive    use of insertionsort */
/* NSRTSZE is for quicksort's nonrecursive use of insertionsort */
#define MRGBSRT  q1ins8
#define BSRTSZE  16
#define RQSIS   q1ins8
#define NQSIS   q1ins8
#define RQSSZE  16
#define NQSSZE  16
#define STSZ    64
#define FIRST_KEY  0
#define MIDDLE_KEY 1
#define RANDOM_KEY 2
#define SPLITTER  MIDDLE_KEY
#define MRGBSRTF f1ins1
#define MRGBSRTD d1ins1
#define MRGBSRTI i1ins1
#define BSRTSZE  16
#define INQSSZE  16
#define INQSIS   i1ins1
/* 2019 code definitions end   here */

#define SWAPP(i1,i2) \
  {ii = size;do {k = *(i1);*(i1)++ = *(i2);*(i2)++ = k;} while(--ii);}
#define SWAPPY(XX,YY,TT,SS) {DES=(XX);SRC=(YY);M=(SS); do {*TT=*DES;*DES++=*SRC;*SRC++=*TT;} while ( --M); }

/*
#define MEMCPY(X,Y,SIZE)  memcpy((X),(Y),(SIZE))
#undef MEMCPY
*/
#define MEMCPY(XX,YY,SS) {DES=(XX);SRC=(YY);M=(SS); do {*DES++=*SRC++;} while (--M); }
#define IMEMCPY(XX,YY,SS) {DES=(XX);SRC=(YY);M=(SS); do {*DES++=*SRC++;} while (--M); }

void q1ins1 (void *,int ,int ,int (*)(const void*,const void*));
void q1ins2 (void *,int ,int ,int (*)(const void*,const void*));
void q1ins3 (void *,int ,int ,int (*)(const void*,const void*));
void q1ins4 (void *,int ,int ,int (*)(const void*,const void*));
void q1ins5 (void *,int ,int ,int (*)(const void*,const void*));
void q1ins7 (void *,int ,int ,int (*)(const void*,const void*));
void q1inb1 (void *,int ,int ,int (*)(const void*,const void*));
