/**** 2019 (c)  All rights reserved: see agcopy19.txt ****/
#include "agssrti.h"
#ifndef MEMCPY
#define MEMCPY(X,Y,SIZE)  memcpy((X),(Y),(SIZE))
#endif
 /* Iterative MergeSort with baseline InsertionSort */

void d4mrgit1(data   *keys,int n)
{
 register int M;
 register char *SRC, *DES;
 register data   *S, *D, *T, *kys;
 register int i, j, k, r, t, LB, RB;
 data     *ktmp;

 if (n <  2   ) return;
 kys  = keys ;
 ktmp = (data   *) malloc(n*sizeof(data  ));

 for(t=0; t < n ; t+=BSRTSZE) {
    MRGBSRTD(kys + t, MIN(BSRTSZE, (n-t)));
 }

 S=kys; D=ktmp;
 for(r= BSRTSZE ; r < n ; r = (r<<1)) {
     for(t=0 ; t < n; t += (r<<1)) {
        LB=MIN(t+r, n); RB=MIN(t+(r<<1), n);
        i = t ; j = LB ; k = t;
        while ((i< LB) && (j< RB)) {
           if (S[j] < S[i]) {
              D[k] = S[j];
              ++j; ++k;
           }
           else {
              D[k] = S[i];
              ++i;++k;
           }
         }

         if (i< LB) MEMCPY((char*)(D+k), (char*)(S+i), (LB-i)*sizeof(data  ));
         if (j< RB) MEMCPY((char*)(D+k), (char*)(S+j), (RB-j)*sizeof(data  ));
      }
      T=S; S=D; D=T;
 }

  if (S!=kys) MEMCPY((char*)kys,(char*)S,n*sizeof(data  ));
  free(ktmp);
}


