/**** 2019 (c)  All rights reserved: see agcopy19.txt ****/
#include "agssrti.h"
#ifndef MEMCPY
#define MEMCPY(X,Y,SIZE)  memcpy((X),(Y),(SIZE))
#endif

 /* Data QuickSort Recursive Hoare with inline memcpy/InsrtionSort   */

void d6qkrw1a (data *akeys, int   n)
{
 register data  split, tmp;
 register int  l, r;
 register data *keys=(data*)akeys;

 if (n <=1) return;
 l=0;r=n-1;
#if   SPLITTER == MIDDLE_KEY
 split=keys[n/2];
#elif SPLITTER == FIRST_KEY
 split=keys[l];
#elif SPLITTER == RANDOM_KEY
 split=keys[GRANDOM(n)];
#endif

 while (l<=r) {
   while (keys[l]<split) l++;
   while (keys[r]>split) r--;
   if (l <= r) {
     tmp=keys[l];
     keys[l]=keys[r];
     keys[r]=tmp;
     l++;r--;
   }
 }

  if (r>0) {
    if ((r+1)< INQSSZE ) INQSIS(keys,r+1);
    else d6qkrw1a(keys,r+1);
  }
  if (l<n) {
    if ((n-l)< INQSSZE ) INQSIS(&keys[l],n-l);
    else d6qkrw1a(&keys[l],n-l);
  }
}

void d6qkrw1 (data *keys, int n)
{
  if (n <= 1) return ;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
  d6qkrw1a (keys,n);
}

 /* Data QuickSort Recursive Hoare with inline memcpy/InsrtionSort   */
void d6qkrw5a (data *akeys, int   n, int *L,int *R)
{
  register int  l,r,mL,mR;
  register data *keys=akeys;
  register data split, tmp;


  if ((*R-*L) <= 0) return ; /* if ((*R-*L+1) <= 1) return ; */

   mL=*L;mR=*R;
  while (mL < mR ) {
     l=mL;r=mR;
#if   SPLITTER == MIDDLE_KEY
 split=keys[(l+r)/2];
#elif SPLITTER == FIRST_KEY
 split=keys[l];
#elif SPLITTER == RANDOM_KEY
 split=keys[l+GRANDOM((r-l+1))];
#endif

     while (l <= r) {
         while (keys[l]<split) ++l;
         while (split< keys[r]) --r;
         if (l <= r) { /* is it ok if < ? */
           tmp=keys[l];
           keys[l]=keys[r];
           keys[r]=tmp;
/*
           tmp=*(keys+l);
           *(keys+l)=*(keys+r);
           *(keys+r)=tmp;
*/
           ++l;--r;
         }
     }

   if ((r-mL) < (mR-l)) { /* Left side smaller; eliminated a +1 from both sides */
      if ((r-mL+1) < INQSSZE ) {
         if ((r-mL) >0) {   /* usedto be r-mL+1 > 1 */
           INQSIS(&keys[mL],(r-mL+1));
         }
          mL=l;
      }
      else {
         *R=r; *L=mL; /* mL...r */
         d6qkrw5a(keys,(r-mL+1),L,R);
         mL=l;  /* OR r l ..mR */
      }
   } /*left */
  else {               /* Right side smaller */
      if ((mR-l+1) < INQSSZE ) {
        if ((mR-l) >0) { /* used to be mR-l+1 >1 */
         INQSIS(&keys[l],(mR-l+1));
        }
        mR=r;
      }
      else {
        *L=l; *R=mR;  /* l...mR */
        d6qkrw5a(keys,mR-l+1,L,R);
        mR=r;  /* mL ...r */
      }

  } /*right*/
 }

}

void d6qkrw5 (data *keys, int n)
{
  int myL,myR;
  if (n <= 1) return ;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
  myL=0;myR=n-1;
  d6qkrw5a (keys,n,&myL,&myR);
}
