/****(c) 2020. A. Gerbessiotis. See ../KAagcopy.txt ****/
/*******************************************************/
#include "agsmrgd.h"


void d8mw3 (data *x1, data *x2, int n1, int n2)
{
 register int  i,j,l;
 register data *temp;
 register data a,b;
 register data *s1=(data*) x1,*s2=(data*) x2;
 register int  M;
 register data *SRC, *DES;

 if ((n1<=0)&&(n2<=0)) return;
 temp = (data *) malloc((n1+n2)*sizeof(data));
  i=j=l=0;
  while ((i < n1) && (j < n2)) {
    a = *(s1+i) ;  b= *(s2+j);
    if ( b < a ) {
      *(temp+l) = b;
      ++l; ++j;
    }
    else {
      *(temp+l) = a;
      ++l; ++i;
    }
  }
  if (i < n1) IMEMCPY((temp+l),(s1+i),(n1-i)     );
  if (j < n2) IMEMCPY((temp+l),(s2+j),(n2-j)     );
  IMEMCPY(s1,temp,n1     );
  IMEMCPY(s2,temp+n1     ,n2     );
  free((void *)temp);
}

void d8mw4 (data *x1, data *x2, int n1, int n2)
{
 register int i,j;
 register data *tmp, *temp;
 register data *s1=(data*) x1,*s2=(data*) x2;
 register int M;
 register data *SRC, *DES;

 if ((n1<=0)&&(n2<=0)) return;
 tmp = (data *) malloc((n1+n2)*sizeof(data));
 temp=tmp;
 i=j=0;
  while ((i < n1) && (j < n2)) {
    if ( *s2 < *s1  ) {
      *tmp = *s2;
      ++j;++s2; ++tmp;
    }
    else {
      *tmp = *s1;
      ++i;++s1; ++tmp;
    }
  }

  if (i < n1)  IMEMCPY(tmp,s1,(n1-i)     );
  if (j < n2)  IMEMCPY(tmp,s2,(n2-j)     ); 
  IMEMCPY(x1,temp,n1   );
  IMEMCPY(x2,temp+n1,n2);
  free((void *)temp);
}



