/****(c) 2020. A. Gerbessiotis. See ../KAagcopy.txt ****/
/*******************************************************/
#include "agssrtd.h"
#ifndef MEMCPY
#define MEMCPY(X,Y,SIZE)  memcpy((X),(Y),(SIZE))
#endif
 /* (Straight) Insertion Sort */

void d1ins1(ddata *akeys,int n)
{   /* j=i-1 */
  register int i,j;
  register ddata k;

  if (n<=1) return;
  for(i=1;i<n;++i){
     k=akeys[i];
     j=i-1; 
     while((j>=0)&&(akeys[j]>k)){
        akeys[j+1]=akeys[j];
        --j ; 
     }
     akeys[j+1]=k;
  }
}

void d1ins2(ddata *akeys,int n)
{   /* j=i */
  register int i,j;
  register ddata k;

  if (n<=1) return;
  for(i=1;i<n;++i){
     k=akeys[i];
     j=i; 
     while((j> 0)&&(akeys[j-1]>k)){
        akeys[j]=akeys[j-1];
        --j ; 
     }
     akeys[j]=k;
  }
}

void d1ins3(ddata *akeys,int n)
{   /* j=i-1 , p */
  register int i,j;
  register ddata *p,k;

  if (n <= 1) return;
  for(i=1;i<n;++i) {
     k=akeys[i];
     j=i-1;  p = akeys+j;
     while ( (j >= 0 ) && (*p > k )) {
        *(p+1)= *p;
        --j; --p;
     }
     *(p+1)=k;
  }
}

void d1ins4(ddata *akeys,int n)
{   /* j=i , p */
  register int i,j;
  register ddata *p,k;

  if (n <= 1) return;
  for(i=1;i<n;++i) {
     k=akeys[i];
     j=i;  p = akeys+(j-1);
     while ( (j >  0 ) && (*p > k )) {
        *(p+1)= *p;
        --j; --p;
     }
     *(p+1)=k;
  }
}

void d1ins5(ddata *akeys,int n)  /* d1ins21 or  i21ins seqo.c */
{   /* j=i-1 , p, ip */
  register ddata *p,*ip,k;

  if (n <= 1) return;
  for(ip=akeys+1;ip<(akeys+n);++ip) {
     k=*ip;
     p=ip-1;
     while ( ( p >= akeys ) && (*p > k )) { 
        *(p+1)= *p;
         --p;
     }
     *(p+1)=k;
  }
}

void d1ins6(ddata *akeys,int n)
{   /* j=i-1 , p, ip */
  register ddata *p,*ip,k;

  if (n <= 1) return;
  for(ip=akeys+1;ip<(akeys+n);++ip) {
     k=*ip;
     p=ip;
     while ( ( p >  akeys ) && (*(p-1) > k )) {  /* ip >= akeys becomes p >= akeys */
        *(p)= *(p-1);
         --p;
     }
     *(p)=k;
  }
}

void d1ins7(ddata *akeys,int n)  /* i22ins of seqo.c */
{   /* j=i-1 , p, ip, for */
  register ddata *p,*ip,k;

  if (n <= 1) return;
  for(ip=akeys+1;ip<(akeys+n);++ip) {
     k=*ip;
     for( p = ip ; ( p > akeys) && (*(p-1) > k) ; --p){
        *p= *(p-1);
     }
     *p=k;
  }
}

void d1ins8(ddata *akeys, int n)  /* d1ins5 renamed? ex d21ins */
{
 register ddata *p, *jp,k;

 if (n <=1) return;
 for(jp=akeys+1; jp<(akeys+n); jp++) {
   k=*jp;
   p=jp-1;
   while ( (p>= akeys) && ( *p > k )) {
     *(p+1) = *p;
     --p;
   }
   *(p+1)=k;
 }
}


/* BinarySearch Insertion Sort */

void d1inb1(ddata *akeys, int n)
{
 register int i,j,l,r,m;
 register ddata  x,*keys=akeys;

 if (n<=1) return;

 for(i=1;i<n;++i) {
    x= *(keys+i); /* &keys[i*size] */
    l=0;r=i-1;
    while (l <= r) {
       m = (l+r)/2;
       if (x < *(keys+m)) /* &keys[m*size] */
          r=m-1;
       else
          l=m+1;
    }

 for(j=i-1;j>=l;j--)
    *(keys+j+1) = *(keys+j);
 *(keys+l) = x;
 }
}

