/****Copyright (c) 1997-2004 All rights reserved
 ****A. V. Gerbessiotis 
 ****Permission to use, copy, modify, and distribute this software,
 ****and to incorporate it, in whole or in part, into 
 ****other software,is hereby granted without fee, provided that
 ****  (1) the above copyright notice and this permission 
 ****      notice appear in all copies of the source code, and 
 ****      the above copyright notice appear in clearly visible 
 ****      form on all supporting documentation and distribution 
 ****      media, and
 ****     (2) any redistribution of the software, in original
 ****         or modified form, be without fee and subject to
 ****         these same conditions.
 ****   No guarantee, whatsoever, is offered that the code works as
 ****   advertised or is absent of any, even damaging,
 ****   side-effects. Use this code at your own personal risk.
 ****/
#include "ssrt.h"

void ag71qsrtm(void *akeys, int n, int size, int (*compare) (const void*,const void*),int l,int r)
{
 register int i,j,M,c;
 char x[64];
 register char *keys, *DES,*SRC;
 register char *pi,*pj;

 keys=(char *) akeys;
 i=l;j=r;
 pi= &keys[l*size];
 pj= &keys[r*size];

/*
 x = (char *) malloc(size*sizeof(char));
 y = (char *) malloc(size*sizeof(char));
*/
 MEMCPY(x,&keys[((l+r)>>1)*size],size);

do
{
        while (compare(pi,x) < 0)  {i++; pi += size;}
        while (compare(x,pj) < 0)  {j--; pj -= size;}
	if (i <= j ) {
/*
          MEMCPY(y,pi,size);
         MEMCPY(pi,pj,size);
MEMCPY(pj,y,size);
i++;j--; pi += size;pj -= size;
*/
	  M=size;
          do  {
             c=*pi; *pi++=*pj;*pj++=c;} while (--M);
		i++;j--;pj-=size;pj-=size;
	}
} while (i <= j);
	
	if (l < j) {
		if ((j-l) < THRES16)
			BASES (&keys[l*size],(j-l+1),size,compare);
		else
			ag71qsrtm(keys,n,size,compare,l,j);
        }
	if (i < r) {
		if ((r-i) < THRES16)
			BASES (&keys[i*size],(r-i+1),size,compare);
		else
			ag71qsrtm(keys,n,size,compare,i,r);
        }
	
/*
 free((void *)x); free((void *)y);
*/
}

void ag71qsrt(void *keys, int n, int size, int (*compare) (const void*,const void *))
{
  ag71qsrtm(keys,n,size,compare,0,n-1);
}
