/****Copyright (c) 1997-2004 All rights reserved
 ****A. V. Gerbessiotis 
 ****Permission to use, copy, modify, and distribute this software,
 ****and to incorporate it, in whole or in part, into 
 ****other software,is hereby granted without fee, provided that
 ****  (1) the above copyright notice and this permission 
 ****      notice appear in all copies of the source code, and 
 ****      the above copyright notice appear in clearly visible 
 ****      form on all supporting documentation and distribution 
 ****      media, and
 ****     (2) any redistribution of the software, in original
 ****         or modified form, be without fee and subject to
 ****         these same conditions.
 ****   No guarantee, whatsoever, is offered that the code works as
 ****   advertised or is absent of any, even damaging,
 ****   side-effects. Use this code at your own personal risk.
 ****/
#include "ssrt.h"

/* g21mrgnn */
void ag75mrgnn(void *akeys, int n, int size, int (*compare) (const void*,const void*))
{
 register int i,j,k,l,t,h,M,q,p,r,up,m;
 register char *keys,*SRC,*DES,*y;

 keys=(char *) akeys;
 up=1;p=1;
 y = (char*) malloc(2*n*size);
#ifdef SANITY_CHECK
 check_if_null(y,"gmrgr1","y");
#endif
/*
 for(i=0;i<n;i++)
   memcpy(&y[i*size],&keys[i*size],size);
*/
   MEMCPY(y,keys,(size*n));

do {
     h=1; m=n;
     if (up==1) {
       i=0;j=n-1;k=n;l=2*n-1;
     }
     else {
       k=0;l=n-1;i=n;j=2*n-1;
     }
     do {
         if (m >= p) 
           q=p;
         else 
           q=m;
         m=m-q;
         if (m >= p)
           r=p;
         else
           r=m;
         m=m-r;
	 while ((q != 0) && ( r != 0)) {
           if (compare(&y[i*size],&y[j*size]) < 0) {
             MEMCPY(&y[k*size],&y[i*size],size);
             k +=h; i++; q--;
           }
           else {
             MEMCPY(&y[k*size],&y[j*size],size);
             k +=h; j--; r--;
           }
         }
	 while ( r != 0) {
           MEMCPY(&y[k*size],&y[j*size],size);
           k +=h; j--; r--;
         }
         while ( q != 0) {
           MEMCPY(&y[k*size],&y[i*size],size);
           k +=h; i++; q--;
         }
         h=-h; t=k; k=l; l=t;
     } while (m>0);
     up=1-up; p=2*p;
} while (p < n);
/*
    if (up==0)
      for(i=0;i<n;i++)
        memcpy(&y[i*size],&y[(i+n)*size],size);
      for(i=0;i<n;i++)
	memcpy(&keys[i*size],&y[i*size],size);
*/
/*
	if (up==0)
		for(i=0;i<n;i++)
			memcpy(&keys[i*size],&y[(i+n)*size],size);
	else
		for(i=0;i<n;i++)
			memcpy(&keys[i*size],&y[i*size],size);
*/
  if (up==0) {
    MEMCPY(&keys[0*size],&y[(n)*size],(n*size));
  }
  else {
    MEMCPY(&keys[0*size],&y[0*size],(n*size));
  }
}
