/*******************************************************************
*******  Copyright (c)            Alexandros V. Gerbessiotis       *
******* All rights reserved; read copyag.txt file                  *
*******************************************************************/
#include "ssrt.h"

void avg40mi (void *akeys,int n,int size,int (*compare)(const void*,const void*) )
{
 register char *keys=(char*) akeys;
 register char *DES,*SRC;
 register int M,pi,pj,pk;
 register char *temp,*tmp, *s, *t;
 register int  i,j,k,ii,jj,a,b;

 if (n<=1) return;
 temp= (char *) malloc(n*size*sizeof(char));

 b=TMERGE*size;
  for(j=0;j<n;j+=TMERGE,keys+=b) {
      BASES (keys,MIN(TMERGE,(n-j)),size,compare);
  }
  keys=(char*)akeys;
  s=keys;t=temp;
  for(a=TMERGE;a<n;a=(a<<1)) { 
      for (b=0;b<n;b+=(a<<1)) {
         jj=MIN(b+(a<<1),n);ii=MIN((b+a),n);
         i=ii;j=b;k=b;  pi=ii*size; pj=b*size; pk=b*size;
         while ((i<jj)&&(j<ii)) {
           if (compare(s+pi,s+pj)<0) {
              MEMCPY((t+pk),(s+pi),size);
              i++; k++; pi+=size; pk+=size; 
           }
           else {
              MEMCPY((t+pk),(s+pj),size);
              j++;k++; pj+=size;pk+=size;
           }
         }

         if (i<jj) MEMCPY((t+pk),(s+pi),(jj-i)*size);    
         if (j<ii) MEMCPY((t+pk),(s+pj),(ii-j)*size);
        }
      tmp=s;s=t;t=tmp;
    }

  if (s!=keys) MEMCPY(keys,s,n*size); 

  free((void *)temp);
}
