#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#define TT 16

void dstr_insert(char *keys, int n, int size, int (*compare) ())
{
        register int i,j;
        char    *x;

        x = (char *) malloc(size*sizeof(char));
        for(j=1;j<n;j++) {
                memcpy(x,&keys[j*size],size);
                i=j-1;
                while ( (i>=0) && ( compare(&keys[i*size],x)>0) ) {
                        memcpy(&keys[(i+1)*size],&keys[i*size],size);
                        i--;
                }
                memcpy(&keys[(i+1)*size],x,size);
        }
}


void dquick_1_sort(char *keys, int n, int size, int (*compare) (),int l,int r)
{
        register int i,j;
        char    *x,*y;

        i=l;j=r;
        x = (char *) malloc(size*sizeof(char));
        y = (char *) malloc(size*sizeof(char));
        memcpy(x,&keys[((l+r)/2)*size],size);

do
{
        while (compare(&keys[i*size],x) < 0) ++i;
        while (compare(x,&keys[j*size]) < 0) --j;
        if (i <= j ) {
                memcpy(y,&keys[i*size],size);
                memcpy(&keys[i*size],&keys[j*size],size);
                memcpy(&keys[j*size],y,size);
                ++i;--j;
        }
} while (i <= j);

        if (l < j) {
                if ((j-l) < TT)
                        dstr_insert(&keys[l*size],(j-l+1),size,compare);
        }
                else
                        dquick_1_sort(keys,n,size,compare,l,j);
        if (i < r) {
                if ((r-i) < TT)
                        dstr_insert(&keys[i*size],(r-i+1),size,compare);
        }
                else
                        dquick_1_sort(keys,n,size,compare,i,r);

}

void dg67(char *keys, int n, int size, int (*compare) ())
{
                dquick_1_sort(keys,n,size,compare,0,n-1);
}

