/****Copyright (c) 2013-2014 All rights reserved
 ****A. V. Gerbessiotis 
 ****Permission to use, copy, modify, and distribute this software,
 ****and to incorporate it, in whole or in part, into 
 ****other software,is hereby granted without fee, provided that
 ****  (1) the above copyright notice and this permission 
 ****      notice appear in all copies of the source code, and 
 ****      the above copyright notice appear in clearly visible 
 ****      form on all supporting documentation and distribution 
 ****      media, and
 ****     (2) any redistribution of the software, in original
 ****         or modified form, be without fee and subject to
 ****         these same conditions.
 ****   No guarantee, whatsoever, is offered that the code works as
 ****   advertised or is absent of any, even damaging,
 ****   side-effects. Use this code at your own personal risk.
 ****/
#include "ssrt.h"

void g22ins(void *akeys, int n, int size, int (*compare) (const void*,const void*))
{
 register int  M;
 register char *DES,*SRC,*p, *jp;
 register char *keys= (char*) akeys ;
 if (n <=1) return;
 for(jp=keys+size; jp<keys+n*size ; jp+=size) {
   for(p=jp;p > keys &&( compare(p-size,jp)>0); p-=size){
     MEMCPY((p),(p-size),size);
   }
   MEMCPY((p+size),jp,size);
 }
}
