/****Copyright (c) 2014 All rights reserved
 ****A. V. Gerbessiotis 
 ****Permission to use, copy, modify, and distribute this software,
 ****and to incorporate it, in whole or in part, into 
 ****other software,is hereby granted without fee, provided that
 ****  (1) the above copyright notice and this permission 
 ****      notice appear in all copies of the source code, and 
 ****      the above copyright notice appear in clearly visible 
 ****      form on all supporting documentation and distribution 
 ****      media, and
 ****     (2) any redistribution of the software, in original
 ****         or modified form, be without fee and subject to
 ****         these same conditions.
 ****   No guarantee, whatsoever, is offered that the code works as
 ****   advertised or is absent of any, even damaging,
 ****   side-effects. Use this code at your own personal risk.
 ****/
#include "issrt.h"

/* Use i21 or i22 */

void i01ins(idata *keys,int n)
{
  register int i,j;
  register idata tmp;

  if (n<=1) return;
  for(j=1;j<n;++j){
    tmp=keys[j];
#ifndef ALTERNATIVE
    i=j-1; 
    while((i>=0)&&(keys[i]>tmp)){
      keys[i+1] = keys[i];
      i--; 
    }
    keys[i+1]=tmp;
#else
    i=j; 
    while((i>0)&&(keys[i-1]>tmp)){
      keys[i] = keys[i-1];
       i--; 
    }
    keys[i]=tmp;
#endif
  }
}


void i21ins(idata *keys, int n)
{
 register idata *ip, *jp;
 register idata tmp;

 if (n <=1) return;

 for(jp=keys+1; jp<(keys+n); jp++) {
   tmp=*jp;
   ip=jp-1;
   while ( (ip>=keys) && ( *ip > tmp )) {
     *(ip+1) = *(ip);
     ip-=1;
   }
   *(ip+1)=tmp;
 }
}

void i22ins(idata *keys, int n)
{
 register idata *ip, *jp;
 register idata tmp;

 if (n <=1) return;

 for(jp=keys+1; jp<(keys+n); jp++) {
   tmp=*jp;
   for(ip=jp;ip > keys && (*(ip-1) > tmp); ip--){
     *(ip) = *(ip-1);
   }
   *(ip)=tmp;
 }
}


