/****Copyright (c) 1996-2014 All rights reserved
 ****A. V. Gerbessiotis 
 ****Permission to use, copy, modify, and distribute this software,
 ****and to incorporate it, in whole or in part, into 
 ****other software,is hereby granted without fee, provided that
 ****  (1) the above copyright notice and this permission 
 ****      notice appear in all copies of the source code, and 
 ****      the above copyright notice appear in clearly visible 
 ****      form on all supporting documentation and distribution 
 ****      media, and
 ****     (2) any redistribution of the software, in original
 ****         or modified form, be without fee and subject to
 ****         these same conditions.
 ****   No guarantee, whatsoever, is offered that the code works as
 ****   advertised or is absent of any, even damaging,
 ****   side-effects. Use this code at your own personal risk.
 ****/
#include "issrt.h"

void i30mi (idata *akeys,int n)
{
  register idata *DES,*SRC;
  register int M;
  register idata *temp,*tmp, *s, *t;
  register int  i,j,k,ii,jj,a,b;
  register idata *keys= akeys;

  if (n<=1) return;
  temp=(idata*)malloc(n*sizeof(idata));

  a=n/TMERGEI;b=TMERGEI;
  for(j=0;j<a;j++,keys+=b) {
      BASEI (keys,TMERGEI);
  }
  if (a*TMERGEI < n)
    BASEI (keys,n-a*TMERGEI);

  keys=akeys; /* recover original keys */

  s=keys;t=temp;
  for(a=TMERGEI;a<n;a=(a+a)) { 
     for(b=0;b<n;b+=(a+a)) {
         ii=MIN((b+(a+a)),n);jj=MIN((b+a),n);      
         i=jj;j=b;k=b;                        
         while ((i<ii)&&(j<jj)) {
           if (*(s+i) < *(s+j)) {
              *(t+k)=*(s+i);
              i++; k++;
           }
           else {
              *(t+k)= *(s+j);
              j++;k++;
           }
         }
         if (i<ii) IMEMCPY((t+k),(s+i),(ii-i));    
         if (j<jj) IMEMCPY((t+k),(s+j),(jj-j));
     }
     tmp=s;s=t;t=tmp;
  }

  if (s!=keys) IMEMCPY(keys,s,(n)); 

  free((void *)temp);
}
