/****   Copyright (c) 1997-2004  Constantionos J. Siniolakis and
 ****                            Alexandros V. Gerbessiotis
 ****
 ****   Permission to use, copy, modify, and distribute this software,
 ****   and to incorporate it, in whole or in part, into other software,
 ****   is hereby granted without fee, provided that
 ****     (1) the above copyright notice and this permission notice appear in
 ****         all copies of the source code, and the above copyright notice
 ****         appear in clearly visible form on all supporting documentation
 ****         and distribution media, and
 ****     (2) any redistribution of the software, in original
 ****         or modified form, be without fee and subject to
 ****         these same conditions.
 ****   No guarantee is offered that the code works as
 ****   advertised or is absent of any, even damaging,
 ****   side-effects; use this code on your own personal risk
 ****/

#include        "issrt.h"

/*** FLog2 */
int FLog2 (int x)
{
  register int l;
  if (x <= 1) {
      return(0);
  } else {
      l = 0;
      while ((x = Div2(x)) != 0) l++;
      return(l);
  }
}

/*** CLog2 */
int CLog2 (int x)
{
  register int l;
  if (x <= 1) {
     return(0);
  } else {
      x--; l = 1;
      while ((x = Div2(x)) !=0) l++;
      return(l);
  }
}

/*** Exp2 */
int Exp2 (int x)
{
  return (int)((unsigned int)(1) << x);
}



