/****Copyright (c) 2013-2014 All rights reserved
 ****A. V. Gerbessiotis 
 ****Permission to use, copy, modify, and distribute this software,
 ****and to incorporate it, in whole or in part, into 
 ****other software,is hereby granted without fee, provided that
 ****  (1) the above copyright notice and this permission 
 ****      notice appear in all copies of the source code, and 
 ****      the above copyright notice appear in clearly visible 
 ****      form on all supporting documentation and distribution 
 ****      media, and
 ****     (2) any redistribution of the software, in original
 ****         or modified form, be without fee and subject to
 ****         these same conditions.
 ****   No guarantee, whatsoever, is offered that the code works as
 ****   advertised or is absent of any, even damaging,
 ****   side-effects. Use this code at your own personal risk.
 ****/
#include "issrt.h"
/* Standard quicksort(Hoare) with inline memcpy (mostly) and insertion sort  :LUNATIC but ...*/

/* 
    char*
    med50(char *a, char *b, char *c, int (*cmp)(const void *, const void *))
    {
            return cmp(a, b) < 0 ?  (cmp(b, c) < 0 ? b : (cmp(a, c) < 0 ? c : a ))
                                 :  (cmp(b, c) > 0 ? b : (cmp(a, c) < 0 ? a : c ));
    }
*/


void o50qwm(idata *akeys, int   n, int *L,int *R)
{
  register int  l,r,mL,mR;
  register idata *keys=akeys;
  register idata split, tmp,*pi,*jp , *ip;


  if ((*R-*L) <= 0) return ; /* if ((*R-*L+1) <= 1) return ; */

   mL=*L;mR=*R;
  while (mL < mR ) { 
     l=mL;r=mR;
#if   SPLITTER == MIDDLE_KEY
 split=keys[(l+r)/2];
#elif SPLITTER == FIRST_KEY
 split=keys[l];
#elif SPLITTER == RANDOM_KEY
 split=keys[l+GRANDOM((r-l+1))];
#endif

     while (l <= r) {
         while (keys[l]<split) l++;
         while (split< keys[r]) r--;
         if (l <= r) { /* is it ok if < ? */
           tmp=keys[l];
           keys[l]=keys[r];
           keys[r]=tmp;
/*
           tmp=*(keys+l);
           *(keys+l)=*(keys+r);
           *(keys+r)=tmp;
*/
           l++;r--;
         }
     }
  
   if ((r-mL) < (mR-l)) { /* Left side smaller; eliminated a +1 from both sides */
      if ((r-mL+1) < THRESI16) {
         if ((r-mL) >0) {   /* usedto be r-mL+1 > 1 */
            BASEI(&keys[mL],(r-mL+1));
         }
          mL=l;
      }
      else {
         *R=r; *L=mL; /* mL...r */
         o50qwm(keys,(r-mL+1),L,R);
         mL=l;  /* OR r l ..mR */
      }
   } /*left */
  else {               /* Right side smaller */
      if ((mR-l+1) < THRESI16) {
        if ((mR-l) >0) { /* used to be mR-l+1 >1 */
          BASEI(&keys[l],(mR-l+1));
        } 
        mR=r;
      }
      else {
        *L=l; *R=mR;  /* l...mR */
        o50qwm(keys,mR-l+1,L,R);
        mR=r;  /* mL ...r */
      }
      
  } /*right*/
 }

}
           
void o50qw(idata *keys, int n)
{
  int myL,myR;
  if (n <= 1) return ;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
  myL=0;myR=n-1;
  o50qwm(keys,n,&myL,&myR);
}



/************************
 * Note : code differs from CLR Hoare code in the following respect
 *  say input 10 9 8 7 5 and splitter is middle key 8
 *  at termination we have say l=1 r=5 in the beginning
 *            6 7  8 9 10
 *              r    l
 *  lest partition is 6 7 and right partion is ? 9 10 or  8 9 10?
 *  if all keys are equal
 *            8 8  8  8 8 
 *              r     l   at termination
 *  In the g67.c code which is similar (but original and possibly primitive)
 *  left set is L ... r of size r-L+1   base left set keys[L*size]
 *  righ set is l ... R of size R-l+1 correctly identifies keys[l*size]
 *  if g68 and also by extension in g268 we used (pending before potential changes)
 *  left set is size r+1 and right set of size n-l which does not make much sense.
 */
